% file: run_empirical.m 
% run with: kdehmm_experiment6_M3.m
%
% Coded by: JDG
%
% Section 6 (Figures 3 and 4) of CSDA (2022) paper
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all; clc;

datastr = ' ...';

warning('off','all')

default_opts3; % with maxorderm = 10, maxorderh = 100, maxstates = 2    

nr     = ntrain+ntest;
low    = 1;   % low = step "s" number or replications CHANGE
high   = low;

hzon   = 1;   % forecast horizon, CHANGE  
hmax   = 2;   % maximum forecast horizon
window = 1; 

ntrain = 1000; 
ntest  = 1011; 
nr     = ntrain+ntest;

n      = 2012; % total sample size, 550 for training

stat   = zeros(1,n);
states = repelem(-1,n);
obs    = repelem(0,n);

% monthly growth rate of the US industrial production (January 1919 -- March 2020)
% load('Rate_ALL_1214.dat','-ascii');

% daily log-returns of S&P 500 index (3rd January 2012 -- 20th December 2019)
load('SP500_T2012.dat','-ascii'); 
yy =  SP500_T2012';    

clps4_n = zeros(window,1);
clps3_n = zeros(window,1);
clps2_n = zeros(window,1);
clps1_n = zeros(window,1);

for uu = 1:window  % Start rolling forecasting loop
  value = [low  uu];
  disp('uu = ')
  disp(value)
  ntrain = 1000;   

  xt = yy(1:(1000+uu-1));    % training 
  xf = yy(1000+uu+hzon-1);   % forecast values
  xv = xt;
           
  xmin   = min(xt)-10;
  xmax   = max(xt)+10;
  xpts   = linspace(xmin,xmax,ntrain);
  cond   = xt;   % condition on the observations in set xs, rolling

  maxima = estimate_discrete_maxima(xt);  % obtain maxima
  maxima = maxima(xt(maxima) > 50); % Extract non-noise peaks, CHANGE 50

  gammas = phaseinit(datastr,ntrain,maxstates,maxima);

  kdehmm_experiment6_M3(datastr,ntrain,ntest,gridres,condq,maxorderm,maxorderh,...
    maxstates,maxiter,nreinits,inititer,miniter,minstep,gammas,...
    hmmgammainit,xv,xt);  

% Compute conditional pdf at xpts and xf  
  load('matfile.mat')
  
  model1      = mmpts(bestmmos_t_mm,1);
  clps1_n(uu) = condlogprob(model1,cond,xf);      % stationary KDE-MM

  model2      = hmmt(end);                        
  clps2_n(uu) = condlogprob(model2,cond,xf);      % HMM

  model3      = art(bestaro,bestarns);        
  clps3_n(uu) = condlogprob(model3,cond,xf);      % AR-HMM

  model4      = kdeht(1,1);         
  clps4_n(uu) = condlogprob(model4,cond,xf);      % KDE-HMM

end  % end rolling forecasting loop uu=1:window

%%%%%%%%%%%%%%%%%%%%  END MAIN %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
